#!/bin/sh
#
# firelogd	Firewall Log Daemon
#
# chkconfig: 2345 80 60
#
# description:  Firelogd is a daemon that will watch for packets logged
#		by ipchains or iptables and queue them until a threshold
#		is reached. It will then mail them to the administrator.
#

# Source function library.
. /etc/rc.d/init.d/functions

# The following three variables are actually program defaults anyway
#
# How many alerts to queue before mailing
QSIZE=10
# Who is the administrator
MAIL=root
# Where is the output template
TEMPLATE=/etc/firelog.conf


# See how we were called.
case "$1" in
  start)
	status firelogd || /usr/sbin/firelogd -k
	echo -n "Starting firelogd: "
	daemon /usr/sbin/firelogd -b $QSIZE -e $MAIL -t $TEMPLATE
	touch /var/lock/subsys/firelogd
	echo
	;;
  stop)
	echo -n "Stopping firelogd : "
	/usr/sbin/firelogd -k
	rm -f /var/lock/subsys/firelogd
	echo 
	;;
  restart)
	$0 stop
	$0 start
	;;
  status)
	status firelogd
	;;
  *)
	echo "Usage: $0 {start|stop|restart|status}"
	exit 1
esac

exit 0
