#define _GNU_SOURCE

#include "dmn.h"

int
resolve_pkt (struct pktlog *pkt)
{

  extern int lookopt;

  struct servent *new_pt;
  struct hostent *new_hst, hbuf_h;
  struct in_addr hst;

  FILE *extsvc;
  char buf[1024];
  char sportprot[12];
  char dportprot[12];
  int hostbuflen = 1024;
  char *hbuf_c = (char *) malloc (hostbuflen);
  int counter, fndspt, fnddpt, err, rc;

  if (isupper (pkt->proto[0]))
    {
      for (counter = 0; pkt->proto[counter] != '\0'; counter++)
	pkt->proto[counter] = tolower (pkt->proto[counter]);
    }

  if (pkt->ptype == PROTO_TCP || pkt->ptype == PROTO_UDP)
    {
      strcpy (sportprot,
	      pkt->ptype ==
	      PROTO_TCP ? pkt->lvl4.pkt_TCP.srcpt : pkt->lvl4.pkt_UDP.srcpt);
      strcpy (dportprot,
	      pkt->ptype ==
	      PROTO_TCP ? pkt->lvl4.pkt_TCP.dstpt : pkt->lvl4.pkt_UDP.dstpt);
      if (lookopt == USE_EXT_SVC && strcmp (dportprot, "") != 0)
	{
	  if ((extsvc = fopen (SVCFILE, "r")) != NULL)
	    {
	      strcat (sportprot, "/");
	      strcat (dportprot, "/");
	      strcat (sportprot, pkt->proto);
	      strcat (dportprot, pkt->proto);
	      fndspt = fnddpt = 0;
	      while (fgets (buf, sizeof (buf), extsvc) != NULL)
		{
		  if (buf[0] == '#' || buf[0] == '\n'
		      || strlen (buf) < strlen (sportprot)
		      || strlen (buf) < strlen (dportprot))
		    continue;
		  if (!fndspt
		      &&
		      (strncmp
		       (strpbrk (buf + strcspn (buf, "\t "), "0123456789"),
			sportprot, strlen (sportprot)) == 0))
		    {
		      sscanf (buf, "%15s",
			      pkt->ptype ==
			      PROTO_TCP ? pkt->lvl4.pkt_TCP.
			      r_srcpt : pkt->lvl4.pkt_UDP.r_srcpt);
		      fndspt++;
		    }
		  if (!fnddpt
		      &&
		      (strncmp
		       (strpbrk (buf + strcspn (buf, "\t "), "0123456789"),
			dportprot, strlen (dportprot)) == 0))
		    {
		      sscanf (buf, "%15s",
			      pkt->ptype ==
			      PROTO_TCP ? pkt->lvl4.pkt_TCP.
			      r_dstpt : pkt->lvl4.pkt_UDP.r_dstpt);
		      fnddpt++;
		    }
		  if (fndspt && fnddpt)
		    break;
		}
	      fclose (extsvc);
	    }
	  else
	    lookopt = USE_STD_SVC;
	}
      else
	{
	  if (
	      (new_pt =
	       getservbyport (htons
			      (atoi
			       (pkt->ptype ==
				PROTO_TCP ? pkt->lvl4.pkt_TCP.
				dstpt : pkt->lvl4.pkt_UDP.dstpt)),
			      pkt->proto)) != NULL)
	    strncpy (pkt->ptype ==
		     PROTO_TCP ? pkt->lvl4.pkt_TCP.r_dstpt : pkt->
		     lvl4.pkt_UDP.r_dstpt, new_pt->s_name, 16);
	  (pkt->ptype ==
	   PROTO_TCP ? pkt->lvl4.pkt_TCP.r_dstpt : pkt->lvl4.
	   pkt_UDP.r_dstpt)[15] = 0;
	  if (
	      (new_pt =
	       getservbyport (htons
			      (atoi
			       (pkt->ptype ==
				PROTO_TCP ? pkt->lvl4.pkt_TCP.
				srcpt : pkt->lvl4.pkt_UDP.srcpt)),
			      pkt->proto)) != NULL)
	    strncpy (pkt->ptype ==
		     PROTO_TCP ? pkt->lvl4.pkt_TCP.r_srcpt : pkt->
		     lvl4.pkt_UDP.r_srcpt, new_pt->s_name, 16);
	  (pkt->ptype ==
	   PROTO_TCP ? pkt->lvl4.pkt_TCP.r_srcpt : pkt->lvl4.
	   pkt_UDP.r_srcpt)[15] = 0;
	}
    }
  else if (pkt->ptype == PROTO_ICMP)
    {
      icmp_resolve (atoi (pkt->lvl4.pkt_ICMP.type),
		    atoi (pkt->lvl4.pkt_ICMP.code), pkt->lvl4.pkt_ICMP.info);
    }
  else
    return 0;

  for (counter = 0; pkt->proto[counter] != '\0'; counter++)
    pkt->proto[counter] = toupper (pkt->proto[counter]);

  inet_aton (pkt->lvl3.srcip, &hst);
  while ((rc = gethostbyaddr_r ((char *) &hst,
				sizeof (struct in_addr),
				AF_INET,
				&hbuf_h,
				hbuf_c,
				hostbuflen, &new_hst, &err) == ERANGE))
    {
      hostbuflen *= 2;
      hbuf_c = realloc (hbuf_c, hostbuflen);
    }
  if (!(&hbuf_h == NULL || new_hst == NULL))
    strncpy (pkt->lvl3.r_srcip, new_hst->h_name, 255);
  pkt->lvl3.r_srcip[254] = 0;
  inet_aton (pkt->lvl3.dstip, &hst);
  while ((rc = gethostbyaddr_r ((char *) &hst,
				sizeof (struct in_addr),
				AF_INET,
				&hbuf_h,
				hbuf_c,
				hostbuflen, &new_hst, &err) == ERANGE))
    {
      hostbuflen *= 2;
      hbuf_c = realloc (hbuf_c, hostbuflen);
    }
  free (hbuf_c);
  if (!(&hbuf_h == NULL || new_hst == NULL))
    strncpy (pkt->lvl3.r_dstip, new_hst->h_name, 255);
  pkt->lvl3.r_dstip[254] = 0;

  return (1);
}
